##parameters=theme=None, edit_mode=None, REQUEST=None, **kw

if REQUEST is not None:
    kw.update(REQUEST.form)

tmtool = context.portal_themes
templet = context.addTemplet(**kw)
theme_container = tmtool.getThemeContainer(theme=theme)

if templet:
    url = templet.absolute_url() + '/edit_form'
    if theme is not None and edit_mode is not None:
        url += '?theme=%s&edit_mode=%s&cat=general' \
                % (theme, edit_mode)

    default_styles = {}
    for category in templet.getApplicableStyles():
        style_propid =  category['id']
        type_name = category['meta_type']
        style = getattr(context, style_propid, None)
        styles = tmtool.findStylesFor(category=type_name, \
                                            object=templet, title=style)
        if styles['object']:
           default_style = theme_container.getDefaultStyle(type_name)
        else:
           style = theme_container.addPortalStyle(type_name=type_name)
           default_style = getattr(style, 'title', '')
        default_styles[style_propid] = default_style
    if default_styles:
        templet.edit(**default_styles)
else:
    return

if REQUEST is not None:
   REQUEST.RESPONSE.redirect(url)
else:
   return templet
